// File    : TFMTNUM.H
// Author  : Eric Woodruff,  CIS ID: 72134,1150
// Updated : Tue 01/24/95 20:37:28
// Note    : Hereby declared public domain
// Compiler: Borland C++ 3.1 to 4.xx
//
// This file contains the class declaration for the formatted numeric input
// line
//

#if !defined(__TFMTNUM_H)
#define __TFMTNUM_H

class TFormattedNumeric : public TInputLine
{
public:
    TFormattedNumeric(TRect &r, int aMaxLen, TValidator *val = NULL,
        short numDec = 0);
    virtual void handleEvent(TEvent& event);
    virtual void draw(void);
    virtual void setState(ushort aState, Boolean enable);

protected:
    short numDecimals;

    int formatData(char *s, int &dec, Boolean addCommas = True);

private:
    virtual const char *streamableName() const
        { return name; }

protected:
    virtual void write( opstream& );
    virtual void *read( ipstream& );

public:
    TFormattedNumeric( StreamableInit ) : TInputLine(streamableInit) { };
    static const char * const name;
    static TStreamable *build();
};

inline ipstream& operator >> ( ipstream& is, TFormattedNumeric& cl )
    { return is >> (TStreamable&) cl; }
inline ipstream& operator >> ( ipstream& is, TFormattedNumeric*& cl )
    { return is >> (void *&) cl; }

inline opstream& operator << ( opstream& os, TFormattedNumeric& cl )
    { return os << (TStreamable&) cl; }
inline opstream& operator << ( opstream& os, TFormattedNumeric* cl )
    { return os << (TStreamable *) cl; }

#endif  // __TFMTNUM_H
